// Source code to the Ball Shooting Program.
//
// Author: Kelvin Sung
// Copyright: University of Washington, Bothell
//


#pragma once

#ifdef MFC_D3D
#include "../../MFC_D3D/GraphicsAPI/GraphicsAPI.h"
#else
#include "../../FlTk_OpenGL/GraphicsAPI/GraphicsAPI.h"
#endif

class CirclePrimitive {
  public:
    CirclePrimitive(float x, float y);

		float 	VelocityX() const { return Velocity_X; }
		float 	VelocityY() const { return Velocity_Y; }

		float& 	VelocityX() { return Velocity_X; }
		float& 	VelocityY() { return Velocity_Y; }

		void 		UpdatePosition();
		bool 		CollideWith(CirclePrimitive*);
		bool		OutOfBound(float, float);
		bool		PointIsInCircle(float, float);


    // Assume center is defined, set the radius so that the circle touches (x,y)
    void SetRadiusTo(float x, float y);

     // Draw the circle 
    void DrawCircle(GraphicsDevice);

  protected:
    float  Center_X, Center_Y;
		float	 Radius;
		float  Velocity_X, Velocity_Y;
};
