// Source code to the Ball Shooting Program.
//
// Author: Kelvin Sung
// Copyright: University of Washington, Bothell
//

#ifdef MFC_D3D
#include "../../MFC_D3D/StdAfx.h"
#else
#define deviceRegion
#endif
#include "Model.h"

Model::Model()
{
  HeroBall = NULL;
	DefiningNewHero = false;
}

void Model::DrawApplicationState(GraphicsDevice deviceRegion)
{
	// 1. Draw all circles in ModelBalls
	std::vector<CirclePrimitive*>::iterator it;
	it = AllWorldBalls.begin();
	while ( it != AllWorldBalls.end() ) {
		(*it)->DrawCircle(deviceRegion);
		++it;
	}

	// 2. If HeroBall is not in the vector yet, draw it!
	if (DefiningNewHero)
			HeroBall->DrawCircle(deviceRegion);
}
