// Source code to the Ball Shooting Program.
//
// Author: Kelvin Sung
// Copyright: University of Washington, Bothell
//

#pragma once

#include <vector>
						// STD vector class

#include "../GraphicsAPI/CirclePrimitive.h"
						// Graphics API specific stuff


class Model
{
public:
  Model();

  void UpdateModel();

					// Application state inquiry functions
	bool	IsDefiningHeroBall() { return DefiningNewHero; }
	bool	HeroBallExists() { return HeroBall != NULL; }
	int	  NumBallsOnScreen() { return int(AllWorldBalls.size()); }
	float HeroVelocityX()		{	 return HeroBall->VelocityX() * UpdatesPerSecond; }
	float HeroVelocityY()		{  return HeroBall->VelocityY() * UpdatesPerSecond; }
	

					// Support for user requests to change application state
  void 	CreateHeroBall(float x, float y);
  void 	DragHeroBallTo(float x, float y);
  void 	SetHeroBallVelocity(float x, float y);
  void 	InsertHeroToAllWorld();
	void	SelectHeroBallAt(float x, float y);
  void 	SetWorldBound(float width, float height) { WorldWidth = width;  WorldHeight = height; }
	
				// Updates simulation of gravitational force
	void	UpdateSimulation();

				// Redraw application state to the deviceRegion
  void DrawApplicationState(GraphicsDevice);

private:
  CirclePrimitive 					*HeroBall;
	std::vector<CirclePrimitive*>	AllWorldBalls;
	bool											DefiningNewHero;

	float											WorldWidth, WorldHeight;
															// Width and height of the world
};

extern Model				sTheModel;

// We are going to ignore the following warnings ... 
#pragma warning (disable : 4244)
	// conversion from int to float


#pragma warning (disable: 4305)
	// conversion frm float to double

