// Source code to the Ball Shooting Program.
//
// Author: Kelvin Sung
// Copyright: University of Washington, Bothell
//


//
// File: Model_DefineHero: contains all the servicing routine for defining the Hero Object
//
#ifdef MFC_D3D
#include "../../MFC_D3D/StdAfx.h"
#endif
#include "Model.h"

void Model::CreateHeroBall(float x, float y)
{
  HeroBall = new CirclePrimitive(x, y);
  DefiningNewHero = true;
}
		
void Model::DragHeroBallTo(float x, float y)
{
  HeroBall->SetRadiusTo(x, y);
}

void Model::InsertHeroToAllWorld()
{
	AllWorldBalls.push_back(HeroBall);
	DefiningNewHero = false;
}

void Model::SetHeroBallVelocity(float vx, float vy)
{
	if (HeroBall != NULL) {
		HeroBall->VelocityX() = vx/UpdatesPerSecond;
		HeroBall->VelocityY() = vy/UpdatesPerSecond;
	}
}

void Model::SelectHeroBallAt(float x, float y)
{
	bool found = false;
	std::vector<CirclePrimitive*>::iterator it;
	it = AllWorldBalls.begin();
	while ( (!found) && (it != AllWorldBalls.end()) ) {
		if ( (*it)->PointIsInCircle(x, y) ) {
			found = true;
			HeroBall = (*it);
		}
		++it;
	}
}
