// Source code to the Ball Shooting Program.
//
// Author: Kelvin Sung
// Copyright: University of Washington, Bothell
//


//
// Drawing of Circle, this is completely DEPENDENT on GraphicsAPI
//
#include "../../Common/GraphicsAPI/CirclePrimitive.h"

void CirclePrimitive::DrawCircle(GraphicsDevice)
{
  if (Radius <= 0.0f) return;

  float pointSize=2.0f;
	glPolygonMode(GL_FRONT, GL_FILL);
	glPolygonMode(GL_BACK, GL_FILL);

  const int kNumPts = 100;
  float delta = (float)((2.0f * M_PI) / kNumPts);

  // We are going to draw this circle with TriangleFan
	glBegin(GL_TRIANGLE_FAN);

			glColor3f(1.0f, 1.0f, 1.0f);
			glVertex2f(Center_X, Center_Y);

			glColor3f(0.7f, 0.6f, 0.6f);

  		for (int i=0; i<(kNumPts); i++)
  		{

   			float x = Center_X + (Radius * sinf(i*delta));
    		float y = Center_Y + (Radius * cosf(i*delta));
				glVertex2f(x, y);
  		}
			glVertex2f(Center_X, Center_Y+Radius);
	glEnd();
}
