// Source code to the Ball Shooting Program.
//
// Author: Kelvin Sung
// Copyright: University of Washington, Bothell
//


#pragma once


////////////////////////////////////////////////////////////////////////////////////////
//
// Limitation with this API:
//
//
#include <iostream>
#include <cmath>       // for cos(), sin(), and sqrt() 

#include <FL/GLUT.h>
#include <GL/GLU.h>


// Some <math.h> files do not define M_PI... 
// 
#ifndef M_PI
#define M_PI 3.14159265358979323846f
#endif

#ifndef M_VERY_LARGE 
#define M_VERY_LARGE 10000000.0f
#endif


typedef	void GraphicsDevice;
				// this is a D3D device

#define UpdateInterval			25
#define UpdatesPerSecond		40.0f
#define GravityFudgeFactor	100.0f
						// Slow down the freefall so we can actually see something


#define ContinueRefreshThread  	0
#define OneTimeRefreshThread    1

