// Source code to the Ball Shooting Program.
//
// Author: Kelvin Sung
// Copyright: University of Washington, Bothell
//

#include "FlGlutWindow.h"
#include "../../Common/Model/Model.h"

// From Fl_Gl_Window:
//
void	
FlGlutWindow::draw() {
	make_current();		// Fl_Gl_Window function to make current window (Context) current

	//
	// this commands will clear the current Viewport/Scissor
	// area.
	//
	glClearColor(0.8f, 0.8f, 0.95f, 0.0f);
	glClear(GL_COLOR_BUFFER_BIT);
	glMatrixMode(GL_PROJECTION);
		glLoadIdentity();
		gluOrtho2D(0.0f, WorldWidth, 0.0f, WorldHeight);
	TheModel->DrawApplicationState();
}


			////////////////////////////////////////////////////////////////////////
			//
			// Coordinate Transformation support
			//
void 
FlGlutWindow::HardwareToWorldPoint(int hwX, int hwY, float &wcX, float &wcY) {
		wcX = float(hwX) * WorldWidth / float(w());
		wcY = float(h() - hwY) * WorldHeight / float(h());
}
