#include "../GraphicsAPI/GraphicsAPI.h"
#include "MainUIWindow.h"
#include "LargeViewController.h"
#include "SmallViewController.h"

#include "../../Common/Model/Model.h"

#define LocalInterval UpdateInterval
//
// Global event service routines
void Quit() { exit(0); }
void ServiceTimerEvent(int threadFlag)
{
	glutTimerFunc(LocalInterval,   ServiceTimerEvent,  ContinueRefreshThread);

	if (sTheModel.HeroBallExists()) {
			float vx = sTheModel.HeroVelocityX();
			float vy = sTheModel.HeroVelocityY();
			sMainUIWindow->UI.VelocityXSlider->value(vx);
			sMainUIWindow->UI.VelocityYSlider->value(vy);
			char msg[100];
			sprintf(msg, "%6.2f", vx);
			sMainUIWindow->UI.VelocityXEcho->value(msg);
			sprintf(msg, "%6.2f", vy);
			sMainUIWindow->UI.VelocityYEcho->value(msg);
	}
	sTheModel.UpdateSimulation();
	sMainUIWindow->RedrawUIWindow();

	char msg[100];
	sprintf(msg, "Number of Balls=%d", sTheModel.NumBallsOnScreen());
	sMainUIWindow->SendGUIMessage(msg);
}

MainUIWindow::MainUIWindow(Model *w)
{
		TheModel = w;

		float vx, vy, vw, vh;
		vx = UI.LargeViewHolder->x();
		vw =  UI.LargeViewHolder->w();
		vy = UI.LargeViewHolder->y();
		vh =  UI.LargeViewHolder->h();
		UI.LargeViewHolder->hide();

		float sx, sy, sw, sh;
		sx = UI.SmallViewHolder->x();
		sw =  UI.SmallViewHolder->w();
		sy = UI.SmallViewHolder->y();
		sh =  UI.SmallViewHolder->h();
		UI.SmallViewHolder->hide();

		//
		// Creating two Fl_GLUT window inside the main UI window area
		//
		UI.MainUIWindow->begin();

			LargeView = new FlGlutWindow(TheModel, vx, vy, vw, vh, kWorldWidth, kWorldHeight);
			LargeView->make_current();
			LargeView->mouse = LargeView_ServiceMouse;
			LargeView->motion = LargeView_ServiceActiveMotion;
			glutTimerFunc(LocalInterval,   ServiceTimerEvent,  ContinueRefreshThread);

			SmallView = new FlGlutWindow(TheModel, sx, sy, sw, sh, kWorldWidth, kWorldHeight);
			SmallView->make_current();
			SmallView->mouse = SmallView_ServiceMouse;
			SmallView->motion = SmallView_ServiceActiveMotion;
			// SmallView->passivemotion = SmallView_ServicePassiveMotion;

		UI.MainUIWindow->end();

		UI.ShowGUI(0, NULL);
}

void 
MainUIWindow::RedrawUIWindow()
{
		LargeView->draw();
		SmallView->draw();
}
