// Source code to the Ball Shooting Program.
//
// Author: Kelvin Sung
// Copyright: University of Washington, Bothell
//


#pragma once

#include "FlGlutWindow.h"
#include "GUI.h"

#define kWorldWidth		  500.0f
#define kWorldHeight		250.0f

class Model;

class MainUIWindow {
	
	private:

	
		FlGlutWindow		  *LargeView;
		FlGlutWindow		  *SmallView;

		Model							*TheModel;

	public:
		UserInterface		UI;


		MainUIWindow(Model *w);

		void RedrawUIWindow();

		FlGlutWindow*  GetLargeView() { return LargeView; }
		FlGlutWindow*	 GetSmallView() { return SmallView; }

		// Send GUI Message
		// 
		void SendGUIMessage(const char *msg) {
				UI.Message->value(msg);
		}
};

extern MainUIWindow *sMainUIWindow;
extern Model				sTheModel;
