// Source code to the Ball Shooting Program.
//
// Author: Kelvin Sung
// Copyright: University of Washington, Bothell
//


#ifndef  GRAPHICS_API_H
#define  GRAPHICS_API_H


////////////////////////////////////////////////////////////////////////////////////////
//
// Limitation with this API:
//
//
#include "../StdAfx.h"

#include <iostream>
#include <stdio.h>
#include <stdlib.h>
#include <string>
#include <cmath>       // for cos(), sin(), and sqrt() 


#include <d3d9.h>
		// Direct 3D include file (Remember to link with d3d9.lib)

#include <d3dx9mesh.h>
		// for D3DX - classes (e.g. D3DX_VECTOR, etc.)

#include <d3dx9math.h>
		// for D3DX - math classes ... (Remember to link with d3dx9.lib)

#pragma comment(lib, "d3d9.lib")
#pragma comment(lib, "d3dx9.lib")
		// d3d basic lib and d3d extension lib


// Some <math.h> files do not define M_PI... 
// 
#ifndef M_PI
#define M_PI 3.14159265358979323846f
#endif

#ifndef M_VERY_LARGE 
#define M_VERY_LARGE 10000000.0f
#endif


typedef	LPDIRECT3DDEVICE9 GraphicsDevice;
				// this is a D3D device

#define UpdatesPerSecond		40.0f
#define GravityFudgeFactor	100.0f
						// Slow down the freefall so we can actually see something

#endif
