// Source code to the Ball Shooting Program.
//
// Author: Kelvin Sung
// Copyright: University of Washington, Bothell
//


// MainUIWindow.h : header file
//

#pragma once
#include "afxwin.h"
#include "afxcmn.h"
#include "SliderCtrlWithEcho.h"

#include "GraphicsAPI/GraphicsAPI.h"
			// to get the propoer D3D include files

#include "ViewController/CWndD3D.h"
#include "../Common/Model/Model.h"

// MainUIWindow dialog
class MainUIWindow : public CDialog
{
// Construction
public:
	MainUIWindow(CWnd* pParent = NULL);	// standard constructor

// Dialog Data
	enum { IDD = IDD_MAIN_UI_WINDOW };

	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support


// Implementation
protected:
	HICON m_hIcon;

	// Generated message map functions
	virtual BOOL OnInitDialog();
	afx_msg void OnSysCommand(UINT nID, LPARAM lParam);
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	DECLARE_MESSAGE_MAP()
public:

	afx_msg void OnBnClickedQuit();

	// // Status Area for echoing text
	CString EchoArea;
	CString VelocityXEcho;
	CString VelocityYEcho;
	SliderCtrlWithEcho VelocityXSlider;
	SliderCtrlWithEcho VelocityYSlider;

	
	afx_msg void OnTimer(UINT nIDEvent);
	afx_msg void OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar);

private:

	CWndD3D					LargeView;				// One D3D Output Window
	CWndD3D					SmallView;				// The Small View
	Model						TheModel;
	LPDIRECT3D9			D3D;						// Abstract connection to D3D output pipeline
	
};
