// Source code to the Ball Shooting Program.
//
// Author: Kelvin Sung
// Copyright: University of Washington, Bothell
//


// CWndD3D.cpp : implementation file
//

#include "../stdafx.h"
// #include "ClassExample.h"
#include "CWndD3D.h"
#include "../../Common/Model/Model.h"


// CWndD3D

IMPLEMENT_DYNAMIC(CWndD3D, CWnd)
CWndD3D::CWndD3D() :
	D3DDevice(NULL)
{
}

CWndD3D::~CWndD3D()
{
}


BOOL 
CWndD3D::PlaceViewOnReserouce(CWnd *mainUIWindow, unsigned int resourceID)
{
	// a. use the resourceID to figure out how large
	//    is the initial on-screen area for the D3D window
	//
		CWnd* resourceWnd = mainUIWindow->GetDlgItem(resourceID);
		CRect location;
		resourceWnd ->GetWindowRect(&location);


	//
	// b. destroy the place holder, 
	//
		resourceWnd->DestroyWindow();	// Since the static was just a place holder, destroy it
																	// convert the static's screen rectangle to the dialog's 
																	// client coordinates
	//
	// c. use the on-screen area information to create a D3D device
	//
		mainUIWindow->ScreenToClient(&location);
		if (!Create(NULL,					//CWnd default
						NULL,							//has no name
						WS_CHILD|WS_CLIPSIBLINGS|WS_CLIPCHILDREN|WS_VISIBLE|WS_BORDER,
						location,					// Dimension and location of the place-holder
						mainUIWindow,			//	this is the parent
						resourceID) ) { //Use the ID of the just destroyed static
			MessageBox("D3DX Device Creation Failed!!");
			return FALSE;
		}
		
		BringWindowToTop();
		return TRUE;
}


BEGIN_MESSAGE_MAP(CWndD3D, CWnd)
	ON_WM_LBUTTONDOWN()
	ON_WM_LBUTTONUP()
	ON_WM_MOUSEMOVE()
	ON_WM_RBUTTONDOWN()
END_MESSAGE_MAP()



// CWndD3D message handlers

void CWndD3D::OnLButtonDown(UINT nFlags, CPoint point)
{
	float wx, wy;
	HardwareToWorldPoint(point, wx, wy);
	TheModel->CreateHeroBall(wx, wy);
}


void CWndD3D::OnMouseMove(UINT nFlags, CPoint point)
{
	float wx, wy;
	HardwareToWorldPoint(point, wx, wy);
	if (nFlags & MK_LBUTTON) {
		TheModel->DragHeroBallTo(wx, wy);
	}
}

void CWndD3D::OnLButtonUp(UINT nFlags, CPoint point)
{
	TheModel->InsertHeroToAllWorld();
}

void CWndD3D::OnRButtonDown(UINT nFlags, CPoint point)
{
	float wx, wy;
	HardwareToWorldPoint(point, wx, wy);
	TheModel->SelectHeroBallAt(wx, wy);
}
