// Source code to the Ball Shooting Program.
//
// Author: Kelvin Sung
// Copyright: University of Washington, Bothell
//


#pragma once
// CWndD3D

#include "../StdAfx.h"
#include "../GraphicsAPI/GraphicsAPI.h"
		// D3D specific incldues are in GraphicsAPI

class Model;
class CWndD3D : public CWnd
{
	DECLARE_DYNAMIC(CWndD3D)

public:
	CWndD3D();
	virtual ~CWndD3D();

	BOOL	InitD3D(LPDIRECT3D9, float, float);
				// Create and initialize D3D Device (Window)
				// This function is implemented in CWndD3D.cpp
			
	void	RedrawView();
				// Causes the redraw of the D3D Device (Window)kkjj
				// This function is implemented in CWndD3D.cpp
	
	void	SetModel(Model *w) { TheModel = w; }
	
	afx_msg void OnLButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnLButtonUp(UINT nFlags, CPoint point);
	afx_msg void OnMouseMove(UINT nFlags, CPoint point);
	afx_msg void OnRButtonDown(UINT nFlags, CPoint point);

	BOOL	PlaceViewOnReserouce(CWnd *mainUIWindow, unsigned int resourceID);
protected:
	DECLARE_MESSAGE_MAP()
	
private:
	void HardwareToWorldPoint(const CPoint &hwPt, float &worldX, float &worldY) {
			worldX = float(hwPt.x) * WorldMaxX / float(DeviceWidth);
			worldY = float(DeviceHeight- hwPt.y) * WorldMaxY / float(DeviceHeight);
	}
			// D3D Specific 
	LPDIRECT3DDEVICE9 D3DDevice;
				// This is the abstract link to the D3D Device (Window)
	D3DPRESENT_PARAMETERS D3Dpp;  // This is the D3D device description

			// To support Model
	int		DeviceWidth, DeviceHeight;
	float WorldMaxX, WorldMaxY;
	Model	*TheModel;
};


