// Source code to the Ball Shooting Program.
//
// Author: Kelvin Sung
// Copyright: University of Washington, Bothell
//


#include "../StdAfx.h"
#include "CWndD3D.h"
#include "../../Common/Model/Model.h"


void CWndD3D::RedrawView() 
{
	if (D3DDevice == NULL)
		return;

	D3DDevice->Clear(0,															// number of rectangles, 0 means the entire area
					NULL,																				// rectangles to be cleared, NULL means the entire area
					D3DCLEAR_TARGET, 														// clear target (color) (we are not changing the z buffer)
					D3DCOLOR_COLORVALUE(0.8f, 0.8f, 0.95f, 0.0f),// new color to clear to
					0.0f,																				// new Z values to clear to
					0);																					// new Stencil buffer values to clear to

	D3DDevice->BeginScene();

		TheModel->DrawApplicationState(D3DDevice);

	D3DDevice->EndScene();
	D3DDevice->Present(NULL, NULL, NULL, NULL);
}
